#include <cstdio>
typedef long long ll;
ll K,n,m,rank,f[33][33],t[33];
void init()
{
	f[0][0] = 1;
	for (int i = 1; i <= 32; ++i) {
		f[i][0] = f[i - 1][0];
		for (int j = 1; j <= i; ++j)
			f[i][j] = f[i - 1][j] + f[i - 1][j - 1];
	}
}
ll calc(ll x)
{
	for (t[0] = 0; x; x /= 2) t[++t[0]] = (x&1);
	ll res = 0;
	for (int i = t[0],tot = 0; i && K >= tot; --i)
		if (t[i]) res += f[i - 1][K - tot],++tot;
	return res;
}
void getK(ll l, ll r)
{
	ll sum = 0,last = 0;
	for (K = 0; 1; ++K) {
		last = sum;
		if ((sum += (calc(r + 1) - calc(l))) >= rank) break;
	}
	rank -= last;
}
ll work(ll l,ll r)
{
	getK(l,r);
	ll mem = l--;
	while (l + 1 < r) {
		ll mid = (l + r)/2;
		if (calc(mid + 1) - calc(mem) >= rank) r = mid;
		else l = mid;
	}
	return r;
}
int main()
{
	init();
	int T;ll l,r;
	scanf("%d",&T);
	while (T--) {
		scanf("%lld%lld%lld",&m,&n,&rank);
		if (m == 0 && n == 0) {puts("0");continue;}
		if ((n == 0 || m == 0) && rank == 1) {puts("0");continue;}
		if (m == 0) ++m,--rank;
		if (n == 0) --n,--rank;
		if (m < 0) {
			l = (1ll<<32) + m,r = (1ll<<32) + n;
			printf("%lld\n",-(1ll<<32) + work(l,r));
		}else printf("%lld\n",work(m,n));
	}
}